﻿
Namespace Model

    Public Class Contact

        Public Sub New()
            Me.ContactData = New List(Of ContactData)
        End Sub

        Public Sub New(firstName As String, lastName As String, imagePath As String, birthday As Date?, note As String)
            If firstName Is Nothing Then
                Throw New ArgumentNullException(NameOf(firstName))
            End If

            If lastName Is Nothing Then
                Throw New ArgumentNullException(NameOf(lastName))
            End If

            If imagePath Is Nothing Then
                Throw New ArgumentNullException(NameOf(imagePath))
            End If

            If note Is Nothing Then
                note = ""
            End If

            Me.FirstName = firstName
            Me.LastName = lastName
            Me.ImagePath = imagePath
            Me.Birthday = birthday
            Me.Note = note
            Me.ContactData = New List(Of ContactData)
        End Sub

        Public Sub New(firstName As String, lastName As String, imagePath As String, birthday As Date?, note As String, contactData As List(Of ContactData))
            If firstName Is Nothing Then
                Throw New ArgumentNullException(NameOf(firstName))
            End If

            If lastName Is Nothing Then
                Throw New ArgumentNullException(NameOf(lastName))
            End If

            If imagePath Is Nothing Then
                Throw New ArgumentNullException(NameOf(imagePath))
            End If

            If note Is Nothing Then
                Throw New ArgumentNullException(NameOf(note))
            End If

            If contactData Is Nothing Then
                Throw New ArgumentNullException(NameOf(contactData))
            End If

            Me.FirstName = firstName
            Me.LastName = lastName
            Me.ImagePath = imagePath
            Me.Birthday = birthday
            Me.Note = note
            Me.ContactData = contactData
        End Sub

        Public Property FirstName As String
        Public Property LastName As String
        Public Property ImagePath As String
        Public Property Birthday As Date?
        Public Property Note As String
        Public Property ContactData As List(Of ContactData)

    End Class
End Namespace